ompi/mca/ptl/ptl.h File Reference.TH "ompi/mca/ptl/ptl.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/ptl/ptl.h \- P2P Transport Layer (PTL). 
.SH SYNOPSIS
.br
.PP
\fC#include 'mca/mca.h'\fP
.br
\fC#include 'mca/pml/pml.h'\fP
.br
\fC#include 'include/types.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_PTL_PUT\fP   1"
.br
.RI "\fIPTL flags. \fP"
.ti -1c
.RI "#define \fBMCA_PTL_GET\fP   2"
.br
.ti -1c
.RI "#define \fBMCA_PTL_BASE_VERSION_1_0_0\fP"
.br
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef uint64_t \fBmca_ptl_tstamp_t\fP"
.br
.ti -1c
.RI "typedef \fBopal_list_t\fP \fBmca_ptl_queue_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_ptl_base_module_t\fP **(* \fBmca_ptl_base_component_init_fn_t\fP )(int *num_ptls, bool enable_progress_threads, bool enable_mpi_threads)"
.br
.RI "\fIMCA->PTL Intializes the PTL component and creates specific PTL module(s). \fP"
.ti -1c
.RI "typedef int(* \fBmca_ptl_base_component_control_fn_t\fP )(int param, void *value, size_t size)"
.br
.RI "\fIMCA->PTL Called to dynamically change a component parameter. \fP"
.ti -1c
.RI "typedef int(* \fBmca_ptl_base_component_progress_fn_t\fP )(mca_ptl_tstamp_t tstamp)"
.br
.RI "\fIMCA->PTL Called to progress outstanding requests for non-threaded polling environments. \fP"
.ti -1c
.RI "typedef \fBmca_ptl_base_component_1_0_0_t\fP \fBmca_ptl_base_component_1_0_0_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_ptl_base_component_1_0_0_t\fP \fBmca_ptl_base_component_t\fP"
.br
.ti -1c
.RI "typedef int(* \fBmca_ptl_base_module_finalize_fn_t\fP )(struct \fBmca_ptl_base_module_t\fP *ptl)"
.br
.RI "\fIMCA->PTL Clean up any resources held by PTL instance before the module is unloaded. \fP"
.ti -1c
.RI "typedef int(* \fBmca_ptl_base_module_add_procs_fn_t\fP )(struct \fBmca_ptl_base_module_t\fP *ptl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_ptl_base_peer_t\fP **peer, struct ompi_bitmap_t *reachable)"
.br
.RI "\fIPML->PTL notification of change in the process list. \fP"
.ti -1c
.RI "typedef int(* \fBmca_ptl_base_module_del_procs_fn_t\fP )(struct \fBmca_ptl_base_module_t\fP *ptl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_ptl_base_peer_t\fP **)"
.br
.RI "\fIPML->PTL notification of change to the process list. \fP"
.ti -1c
.RI "typedef int(* \fBmca_ptl_base_module_request_init_fn_t\fP )(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_send_request_t\fP *request)"
.br
.RI "\fIPML->PTL Initialize a send request for use by the PTL. \fP"
.ti -1c
.RI "typedef void(* \fBmca_ptl_base_module_request_fini_fn_t\fP )(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_send_request_t\fP *request)"
.br
.RI "\fIPML->PTL Cleanup any resources that may have been associated with the request by the PTL. \fP"
.ti -1c
.RI "typedef int(* \fBmca_ptl_base_module_send_fn_t\fP )(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_peer_t\fP *ptl_base_peer, struct \fBmca_ptl_base_send_request_t\fP *request, size_t offset, size_t size, int flags)"
.br
.RI "\fIPML->PTL Initiate a send to the peer. \fP"
.ti -1c
.RI "typedef int(* \fBmca_ptl_base_module_put_fn_t\fP )(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_peer_t\fP *ptl_base_peer, struct \fBmca_ptl_base_send_request_t\fP *request, size_t offset, size_t size, int flags)"
.br
.RI "\fIPML->PTL Initiate a put to the peer. \fP"
.ti -1c
.RI "typedef int(* \fBmca_ptl_base_module_get_fn_t\fP )(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_peer_t\fP *ptl_base_peer, struct \fBmca_ptl_base_recv_request_t\fP *request, size_t offset, size_t size, int flags)"
.br
.RI "\fIPML->PTL Initiate a get from a peer. \fP"
.ti -1c
.RI "typedef bool(* \fBmca_ptl_base_module_match_fn_t\fP )(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_recv_frag_t\fP *recv_frag, struct \fBmca_ptl_base_match_header_t\fP *header)"
.br
.RI "\fIPTL->PML Notification from the PTL to the PML that a new fragment has arrived and can be matched against posted receives. \fP"
.ti -1c
.RI "typedef void(* \fBmca_ptl_base_module_matched_fn_t\fP )(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_recv_frag_t\fP *request)"
.br
.RI "\fIPML->PTL Notification from the PML to the PTL that a receive has been posted and matched against the indicated fragment. \fP"
.ti -1c
.RI "typedef void(* \fBmca_ptl_base_module_recv_progress_fn_t\fP )(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_recv_request_t\fP *recv_request, size_t bytes_received, size_t bytes_delivered)"
.br
.RI "\fIPTL->PML Notification from the PTL to the PML that a fragment has completed (e.g. \fP"
.ti -1c
.RI "typedef void(* \fBmca_ptl_base_module_send_progress_fn_t\fP )(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_send_request_t\fP *send_request, size_t bytes_sent)"
.br
.RI "\fIPTL->PML Notification from the PTL to the PML that a fragment has completed (e.g. \fP"
.ti -1c
.RI "typedef \fBmca_ptl_base_module_t\fP \fBmca_ptl_base_module_t\fP"
.br
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum \fBmca_ptl_control_t\fP { \fBMCA_PTL_ENABLE\fP }"
.br
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "struct struct struct struct struct struct struct typedef uint64_t \fBmca_ptl_sequence_t\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
P2P Transport Layer (PTL). 

An MCA component type that allows the PML (mca_pml_t) to support a variety of network transports concurrently. The PTL layer is responsible for the reliable delivery of message fragments, while the assignment and scheduling of fragments to PTLs is handled by the upper layer.
.PP
PTL Initialization:
.PP
During library initialization, all available PTL components are loaded and opened via their mca_base_open_component_fn_t function. The PTL open function should register any mca parameters used to tune/adjust the behaviour of the ptl (\fBmca_base_param_register_int()\fP, \fBmca_base_param_register_string()\fP). Note that the open function may fail if the resources (e.g. shared libraries, etc) required by the network transport are not available.
.PP
The \fBmca_ptl_base_component_init_fn_t()\fP is then called for each of the components that are succesfully opened. The component init function may return either:
.PP
(1) a NULL list of PTL instances if the transport is not available, (2) a list containing a single PTL instance, where the PTL provides a layer of abstraction over multiple physical devices (e.g. NICs), (3) a list containing multiple PTL instances where each PTL instance corresponds to a single physical device.
.PP
If multiple network devices are available for a given transport, the preferred approach is (3) above. In this case, the PML layer will handle scheduling across the available resources, and fail-over in the event of a PTL failure. If the second approach is used, and a single PTL instance abstracts multiple physical devices, the PTL assumes all responsibility for scheduling/failover within those devices.
.PP
During module initialization, the module should post any addressing information required by its peers. An example would be the TCP listen port opened by the TCP module for incoming connection requests. This information is published to peers via the \fBmca_pml_base_modex_send()\fP interface. Note that peer information is not guaranteed to be available via \fBmca_pml_base_modex_recv()\fP during the module's init function. However, it will be available during PTL selection (mca_ptl_base_add_proc_fn_t()).
.PP
PTL Selection:
.PP
The PML builds an ordered list of the available PTL instances sorted by their exclusivity ranking. This is a relative ranking that is used to determine the set of PTLs that may be used to reach a given destination. During startup the PTL modules are queried via their mca_ptl_base_add_proc_fn_t() to determine if they are able to reach a given destination. The PTL module with the highest ranking that returns success is selected. Subsequent PTL modules are selected only if they have the same exclusivity ranking.
.PP
An example of how this might be used:
.PP
PTL Exclusivity Comments -------- ----------- ------------------ LO 100 Selected exclusively for local process SM 50 Selected exclusively for other processes on host IB 0 Selected based on network reachability IB 0 Selected based on network reachability TCP 0 Selected based on network reachability TCP 0 Selected based on network reachability
.PP
When a PTL module is selected, it may choose to optionally return a pointer to an an \fBmca_ptl_base_peer_t\fP data structure to the PML. This pointer is treated as an opaque handle by the PML and is returned to the PTL on subsequent data transfer calls to the corresponding destination process. The actual contents of the data structure are defined on a per PTL basis, and may be used to cache addressing or connection information, such as a TCP socket or IB queue pair.
.PP
Send Path:
.PP
When multiple PTLs are available to reach a given destination, a single request (that is large enough) will be split across the available PTLs. For each destination process, the PML maintains two list of PTLs, one set of PTLs that exhibit the lowest latency, and a second set that are used for bulk data transfer. The set of low latency PTLs are used in a round-robin fashion to schedule the first fragment of a message, while the remainder of the message will be scheduled across the second set based on the bandwidth of the available PTLs.
.PP
The PML is responsible for managing the state (allocation, initialization, and release) of send request descriptors (\fBmca_ptl_base_send_request_t\fP). However, to minimize the latency associated with allocating resources to a request, the PML provides the capability to cache send requests descriptors on a per-PTL basis. Each PTL exports two variables (ptl_cache_size and ptl_cache_bytes) that control this behaviour. The variable ptl_cache_size specifies the maximum size of the cache. If a request cannot be provided from the cache, a request descriptor from the global pool will be used instead, and the req_cached attribute of the request set to false. The request cache initially starts off empty and is grown by the PML up to the specified limit. The PTL variable, ptl_cache_bytes, can be used to specify that additional memory should be allocated by the PML in one contigous block along with the base send request (\fBmca_ptl_base_send_request_t\fP) for use by the PTL. The PTLs ptl_request_init() method is then called to initialize this additional memory and associating any PTL specific resources with the request. If a request is removed from the cache, the ptl_request_fini() method will be called to allow the PTL to release any resources associated with the request descriptor.
.PP
When the request is started, the PML will call the selected PTL's ptl_send() method with up to the PTL's threshold (ptl_first_frag_size) bytes of the request. The PTL should attempt to deliver the requested number of bytes. However, this may not be possible due to resource contraints or datatype alignment/offset. The PTL is responsible for updating the number of bytes actually fragmented and queued for delivery on the send request (mca_ptl_base_send_request.req_offset) to reflect the current offset into the send buffer.
.PP
If the request is larger than ptl_first_frag_size, the remainder of the request will be scheduled upon an acknowledgment from the peer that the request has been matched on the receive side. The PTL receiving the fragment is responsible for generating an acknowledgment when the MCA_PTL_FLAGS_ACK bit is set in the flags field of the fragment header. The PTL receiving an ack is responsible for updating the the send request descriptor to point to the matched recv descriptor and the destination buffer address at the remote process. The address of the recv descriptor is sent back in the header of subsequent fragments to avoid the cost of matching the additional fragments at the receiver while the remote address of the destination buffer may be used in subsequent data transfer operations to support RDMA put operations.
.PP
On receipt of an acknowedgment the PTL should call the ptl_send_progress() function to update the status (number of bytes delivered) of the send request. Note that although this function is associated with the PTL, it is provided/ set by the PML during initialization.
.PP
If this was the initial fragment of a large message, the PML will schedule the remaining fragments during this callback. For subsequent fragments the PML will call the PTLs ptl_put() interface function. Since the destination address in the remote process is available, RDMA put operations could be used if supported by the underlying network transport. Note that currently the PML makes no other distinction between ptl_send/ptl_put.
.PP
As subsequent fragments are completed by the PTLs, the ptl_send_progress() function should be called to update the status of request. Note that this may be based on local completion semantics or could require a PTL specific acknowledgment based on the underlying transfer protocol. Upon completion, the PTL is responsible for managing all resources associated with send fragments and their return to internal caches/free lists.
.PP
Recv Path:
.PP
The PML sets two additional callback functions on the PTL during initialization. These callbacks are used by the PTL to notify the PML of receipt of the initial fragment of a new message (ptl_match) and to update the status of a pending receive as fragment(s) complete (ptl_recv_progress).
.PP
The first fragment of a message is sent with a header type of \fBmca_ptl_base_match_header_t\fP. When a header of this type is received, the PTL should call the ptl_match() function as soon as the entire header is available, to determine if a matching receive has been posted. When a matching receive is posted the PTLs ptl_matched() function is called to process the fragment and if required generate an acknowledgment. Note that this call (ptl_matched()) may occur during the call to ptl_match() or at a later point in time if a matching recv has not yet been posted or MPI ordering constraints are not satisfied.
.PP
Prior to calling ptl_matched(), the PML updates the recv fragment descriptor (mca_ptl_recv_frag_t) to point to the matching recv request. If the data associated with the fragment has been received prior to the ptl_matched() call, the PTL should utilize the datatype convertor associated with the recv fragment to copy the data into the users buffer. Note that the datatype convertor provides the capability to unpack the fragment at an arbitrary (e.g. fragment based) offset into the destination buffer. On completion of the data copy, the PTL should call the ptl_recv_progress() function, to update the request completion status.
.PP
If the initial fragment is matched prior to receiving any data associated with the fragment, or in the case of subsequent fragments, the datatype convertor may be used to generate an iovec array of contiguous blocks pointing into the destination buffer, which can be used for zero-copy receives if the underlying transport supports scatter/gather operations.
.PP
The ptl_matched() function should additionally generate, if required, an ack to the source process. An ack is required if the MCA_PTL_FLAGS_ACK bit is set by the source in the flags field of the initial message header. As described above, the generated ack should contain a pointer to the matched receive request, along with the pointer to the destination buffer.
.PP
On receipt of the ack, the source will schedule any remaining fragments. The selected PTLs should generate the remaining fragments with an \fBmca_ptl_base_frag_header_t\fP, which contains a placeholder for a pointer to the matched receive request. This allows the receiver to avoid calling the matching logic for subsequent fragments. On completion of these fragments, the PTL should call the ptl_recv_progress() function to update the request completion status. As fragments are completed, the PTL is responsible for freeing any resources associated with recv fragment descriptors and/or returning them to internal free lists/caches.
.PP
Progress:
.PP
By default, the library provides for polling based progress of outstanding requests. The PTL component exports an interface function (ptlm_progress) that is called in a polling mode by the PML during calls into the MPI library. Note that the ptlm_progress() function is called on the PTL component rather than each PTL instance. This implies that the PTL author is responsible for iterating over the pending operations in each of the PTL modules associated with the component.
.PP
On platforms where threading support is provided, the library provides the option of building with asynchronous threaded progress. In this case, the PTL author is responsible for providing a thread to progress pending operations. A thread is associated with the PTL component/module such that transport specific functionality/APIs may be used to block the thread until a pending operation completes. This thread MUST NOT poll for completion as this would oversubscribe the CPU.
.PP
Note that in the threaded case the PML may choose to use a hybrid approach, such that polling is implemented from the user thread for a fixed number of cycles before relying on the background thread(s) to complete requests. If possible the PTL should support the use of both modes concurrently.
.SH "Define Documentation"
.PP 
.SS "#define MCA_PTL_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/* coll v1.0 is chained to MCA v1.0 */ \
  MCA_BASE_VERSION_1_0_0, \
  /* ptl v1.0 */ \
  'ptl', 1, 0, 0
.fi
.SH "Typedef Documentation"
.PP 
.SS "typedef int(* \fBmca_ptl_base_component_control_fn_t\fP)(int param, void *value, size_t size)"
.PP
MCA->PTL Called to dynamically change a component parameter. 
.PP
\fBParameters:\fP
.RS 4
\fIflag\fP (IN) Parameter to change. 
.br
\fIvalue\fP (IN) Optional parameter value.
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error code on failure.
.RE
.PP
The only supported parameter is currently MCA_PTL_ENABLE, which can be used by the PML to enable/disable forwarding by the PTL. 
.SS "typedef struct \fBmca_ptl_base_module_t\fP**(* \fBmca_ptl_base_component_init_fn_t\fP)(int *num_ptls, bool enable_progress_threads, bool enable_mpi_threads)"
.PP
MCA->PTL Intializes the PTL component and creates specific PTL module(s). 
.PP
\fBParameters:\fP
.RS 4
\fInum_ptls\fP (OUT) Returns the number of ptl instances created, or 0 if the transport is not available.
.br
\fIenable_progress_threads\fP (IN) Whether this component is allowed to run a hidden/progress thread or not.
.br
\fIenable_mpi_threads\fP (IN) Whether support for multiple MPI threads is enabled or not (i.e., MPI_THREAD_MULTIPLE), which indicates whether multiple threads may invoke this component simultaneously or not.
.RE
.PP
\fBReturns:\fP
.RS 4
Array of pointers to PTL modules, or NULL if the transport is not available.
.RE
.PP
During component initialization, the PTL component should discover the physical devices that are available for the given transport, and create a PTL instance to represent each device. Any addressing information required by peers to reach the device should be published during this function via the \fBmca_pml_base_modex_send()\fP interface. 
.SS "typedef int(* \fBmca_ptl_base_component_progress_fn_t\fP)(mca_ptl_tstamp_t tstamp)"
.PP
MCA->PTL Called to progress outstanding requests for non-threaded polling environments. 
.PP
\fBParameters:\fP
.RS 4
\fItstamp\fP Current time. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error code on failure. 
.RE
.PP

.SS "typedef int(* \fBmca_ptl_base_module_add_procs_fn_t\fP)(struct \fBmca_ptl_base_module_t\fP *ptl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_ptl_base_peer_t\fP **peer, struct ompi_bitmap_t *reachable)"
.PP
PML->PTL notification of change in the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fInprocs\fP (IN) Number of processes 
.br
\fIprocs\fP (IN) Set of processes 
.br
\fIpeer\fP (OUT) Set of (optional) \fBmca_ptl_base_peer_t\fP instances returned by PTL. 
.br
\fIreachable\fP (OUT) Bitmask indicating set of peer processes that are reachable by this PTL. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI_SUCCESS or error status on failure.
.RE
.PP
The \fBmca_ptl_base_module_add_procs_fn_t()\fP is called by the PML to determine the set of PTLs that should be used to reach each process. Any addressing information exported by the peer via the \fBmca_pml_base_modex_send()\fP function should be available during this call via the corresponding \fBmca_pml_base_modex_recv()\fP function. The PTL may utilize this information to determine reachability of each peer process.
.PP
For each process that is reachable by the PTL, the bit corresponding to the index into the proc array (nprocs) should be set in the reachable bitmask. The PML provides the PTL the option to return a pointer to a data structure defined by the PTL that is returned to the PTL on subsequent calls to the PTL data transfer functions (e.g ptl_send). This may be used by the PTL to cache any addressing or connection information (e.g. TCP socket, IP queue pair). 
.SS "typedef int(* \fBmca_ptl_base_module_del_procs_fn_t\fP)(struct \fBmca_ptl_base_module_t\fP *ptl, size_t nprocs, struct ompi_proc_t **procs, struct \fBmca_ptl_base_peer_t\fP **)"
.PP
PML->PTL notification of change to the process list. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fInprocs\fP (IN) Number of processes 
.br
\fIproc\fP (IN) Set of processes 
.br
\fIpeer\fP (IN) Set of peer addressing information. 
.RE
.PP
\fBReturns:\fP
.RS 4
Status indicating if cleanup was successful
.RE
.PP
When the process list changes, the PML notifies the PTL of the change, to provide the opportunity to cleanup or release any resources associated with the peer. 
.SS "typedef int(* \fBmca_ptl_base_module_finalize_fn_t\fP)(struct \fBmca_ptl_base_module_t\fP *ptl)"
.PP
MCA->PTL Clean up any resources held by PTL instance before the module is unloaded. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance.
.RE
.PP
Prior to unloading a PTL module, the MCA framework will call the PTL finalize method of the module. Any resources held by the PTL should be released and if required the memory corresponding to the PTL module freed. 
.SS "typedef int(* \fBmca_ptl_base_module_get_fn_t\fP)(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_peer_t\fP *ptl_base_peer, struct \fBmca_ptl_base_recv_request_t\fP *request, size_t offset, size_t size, int flags)"
.PP
PML->PTL Initiate a get from a peer. 
.PP
(NOT IMPLEMENTED)
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIptl_base_peer\fP (IN) PTL peer addressing 
.br
\fIrequest\fP (IN) Recv request 
.br
\fIoffset\fP Current offset into packed/contiguous buffer. 
.br
\fIsize\fP (IN/OUT) Number of bytes PML is requesting PTL to pull from peer, PTL returns number of bytes sucessfully fragmented. 
.br
\fIflags\fP (IN) 
.br
\fIrequest\fP (OUT) OMPI_SUCCESS if the PTL was able to queue one or more fragments
.RE
.PP
The PML does NOT currently utilize this I/F. 
.SS "typedef bool(* \fBmca_ptl_base_module_match_fn_t\fP)(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_recv_frag_t\fP *recv_frag, struct \fBmca_ptl_base_match_header_t\fP *header)"
.PP
PTL->PML Notification from the PTL to the PML that a new fragment has arrived and can be matched against posted receives. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrecv_frag\fP Receive fragment 
.br
\fIheader\fP (IN) Message header
.RE
.PP
The ptl_match() function is called by the PTL on receipt of an initial fragment of a new message. The PML sets a default matching function on the PTL (ptl_match) when the PTL is initialized. This function attempts to match the header corresponding to the receive fragment to posted receives. When a match is made, the PTLs ptl_matched() function is called. Note that this may occur during the call to ptl_match(), or later in time if a matching receive has not yet been posted or the receive fragment is out-of-order. 
.SS "typedef void(* \fBmca_ptl_base_module_matched_fn_t\fP)(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_recv_frag_t\fP *request)"
.PP
PML->PTL Notification from the PML to the PTL that a receive has been posted and matched against the indicated fragment. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrecv_frag\fP Matched fragment
.RE
.PP
The ptl_matched() function is called by the PML when a fragment is matched to a posted receive. This may occur during a call to ptl_match() if the receive is matched, or at a later point in time when a matching receive is posted.
.PP
When this routine is called, the PTL is responsible for generating an acknowledgment to the peer if the MCA_PTL_FLAGS_ACK bit is set in the original fragment header. Additionally, the PTL is responsible for transferring any data associated with the fragment into the users buffer utilizing the datatype engine, and notifying the PML that the fragment has completed via the ptl_recv_progress() function. 
.SS "typedef int(* \fBmca_ptl_base_module_put_fn_t\fP)(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_peer_t\fP *ptl_base_peer, struct \fBmca_ptl_base_send_request_t\fP *request, size_t offset, size_t size, int flags)"
.PP
PML->PTL Initiate a put to the peer. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIptl_base_peer\fP (IN) PTL peer addressing 
.br
\fIrequest\fP (IN) Send request 
.br
\fIoffset\fP Current offset into packed/contiguous buffer. 
.br
\fIsize\fP (IN/OUT) Number of bytes PML is requesting PTL to deliver, PTL returns number of bytes sucessfully fragmented 
.br
\fIflags\fP (IN) Flags that should be passed to the peer via the message header. 
.br
\fIrequest\fP (OUT) OMPI_SUCCESS if the PTL was able to queue one or more fragments
.RE
.PP
When the message exceeds the PTLs initial fragment size (ptl_first_frag_size), the PML schedules the remainder of the message after an ack is received for the first fragment. When the remaining fragments are scheduled the PML calls the the ptl_put() I/F function rather than ptl_send(), to indicate that the address of the destination buffer at the remote process is available, allowing for an RDMA put if supported by the underlying transport.
.PP
The PTL is responsible for updating the current data offset (req_offset) in the request to reflect the actual number of bytes fragmented. This may be less than the requested size, due to resource constraints or datatype alighnment/offset. The PTL must call the ptl_send_progress() function to indicate completion of each fragment. 
.SS "typedef void(* \fBmca_ptl_base_module_recv_progress_fn_t\fP)(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_recv_request_t\fP *recv_request, size_t bytes_received, size_t bytes_delivered)"
.PP
PTL->PML Notification from the PTL to the PML that a fragment has completed (e.g. 
.PP
been successfully delivered into users buffer)
.PP
\fBParameters:\fP
.RS 4
\fIptr(IN)\fP PTL instance 
.br
\fIrecv_request\fP (IN) Receive Request 
.br
\fIbytes_received\fP (IN) Number of bytes received from peer. 
.br
\fIbytes_delivered\fP (IN) Number of bytes delivered to application.
.RE
.PP
The PML sets this function pointer during module initialization to allow the PTL to make upcalls back into the PML as fragments complete. 
.SS "typedef void(* \fBmca_ptl_base_module_request_fini_fn_t\fP)(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_send_request_t\fP *request)"
.PP
PML->PTL Cleanup any resources that may have been associated with the request by the PTL. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrequest\fP (IN) Pointer to allocated request.
.RE
.PP
The ptl_request_fini function is called when the PML removes a request from the PTLs cache (due to resource constraints). This routine provides the PTL the chance to cleanup/release any resources cached on the send descriptor by the PTL. 
.SS "typedef int(* \fBmca_ptl_base_module_request_init_fn_t\fP)(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_send_request_t\fP *request)"
.PP
PML->PTL Initialize a send request for use by the PTL. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIrequest\fP (IN) Pointer to allocated request.
.RE
.PP
To reduce latency (number of required allocations), the PML allocates up to ptl_cache_bytes of additional space contigous w/ the base send request. This space may be used by the PTL for additional control information (e.g. first fragment descriptor).
.PP
The ptl_request_init() function is called by the PML when requests are allocated to the PTLs cache. These requests will be cached by the PML on completion and re-used by the same PTL w/out additional calls to ptl_request_init().
.PP
If the cache size is exceeded, the PML may pass requests to ptl_send/ptl_put that have been taken from the global pool and have not been initialized by the PTL. These requests will have the req_cached attribute set to false. 
.SS "typedef int(* \fBmca_ptl_base_module_send_fn_t\fP)(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_peer_t\fP *ptl_base_peer, struct \fBmca_ptl_base_send_request_t\fP *request, size_t offset, size_t size, int flags)"
.PP
PML->PTL Initiate a send to the peer. 
.PP
\fBParameters:\fP
.RS 4
\fIptl\fP (IN) PTL instance 
.br
\fIptl_base_peer\fP (IN) PTL peer addressing 
.br
\fIrequest\fP (IN) Send request 
.br
\fIoffset\fP Current offset into packed/contiguous buffer. 
.br
\fIsize\fP (IN) Number of bytes PML is requesting PTL to deliver, 
.br
\fIflags\fP (IN) Flags that should be passed to the peer via the message header. 
.br
\fIrequest\fP (OUT) OMPI_SUCCESS if the PTL was able to queue one or more fragments
.RE
.PP
The PML implements a rendevouz protocol, with up to the PTL threshold (ptl_first_frag_size) bytes of the message sent in eager send mode. The ptl_send() function is called by the PML to initiate the send of the first message fragment.
.PP
The PTL is responsible for updating the current data offset (req_offset) in the request to reflect the actual number of bytes fragmented. This may be less than the requested size, due to resource constraints or datatype alighnment/offset. If an acknowledgment is required, the MCA_PTL_FLAGS_ACK bit will be set in the flags parameter. In this case, the PTL should not call ptl_send_progress() function to indicate completion of the fragment until the ack is received. For all other fragments ptl_send_progress() may be called based on local completion semantics. 
.SS "typedef void(* \fBmca_ptl_base_module_send_progress_fn_t\fP)(struct \fBmca_ptl_base_module_t\fP *ptl, struct \fBmca_ptl_base_send_request_t\fP *send_request, size_t bytes_sent)"
.PP
PTL->PML Notification from the PTL to the PML that a fragment has completed (e.g. 
.PP
been successfully delivered to peer)
.PP
\fBParameters:\fP
.RS 4
\fIptr(IN)\fP PTL instance 
.br
\fIsend_request\fP (IN) Send Request 
.br
\fIbytes_sent\fP (IN) Number of bytes sent to peer.
.RE
.PP
The PML sets this function pointer during module initialization to allow the PTL to make upcalls back into the PML as fragments complete. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
